This library has functions for operating on the bit representation of numbers; in other words, the base 2 representation.

The progsbase system works on flaoting point numbers with 15 decimal digits, which means each number variable can hold 49 bits. The functions in this library works on 32 bits or less. Before bitwise operations are performed on the number, it is truncated and then checked to be within the bit-bounds. If not within the bounds, the bitwise functions return 0.

The first category include bitwise operators, which include Not, And, Or and Xor.

The second category include bit shift operators, which include right and left shift.

These two categories of functions are commonly found in hardware on modern processors. They are also included as operators in most modern programming languages (although with a differing implementation). In progsbase, the behavior is the same for all target languages.

The bitwise functions are translated into bitwise operators if available in the target language.

The third category of functions works on bit arrays, each number in the array holding 32 bits.